        sub NDSPaths
	Set rs = CreateObject("WScript.Shell")
	on error resume next
	NDSRSrvPATH = rs.RegRead("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\NDS Server0\ImagePath")

	dibdir = InStr(NDSRSrvPATH, "=")
	dibdir = dibdir+2
	enddibdir = InStr(dibdir,NDSRSrvPATH, "DIBFILES",1)
	pathlength = enddibdir - dibdir - 1
	NDSRPATH = Mid(NDSRSrvPATH,dibdir,pathlength)
	
	imanloc = rs.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Novell iManager\InstallLocation")
	
	If NDSRPATH = "" Then
	    on error resume next
		
	    if imanloc = "" then 
			NDSRPATH = InputBox("Enter the path where eDirectory resides (dhost.exe)" & (chr(13) & chr(10)) & "Press Cancel to abort this update." , "Security Update 8", "c:\novell\nds")
			if NDSRPATH = "" then redver2 = "4"
	    end if
	end if

	if imanloc <> "" then 
		imansvc = rs.RegRead("HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\Tomcat\DisplayName")
		
		if imansvc = "" then 
			sndmsg = msgbox("The Tomcat service can not be detected by this install." & (chr(13) & chr(10)) & "This may be because Tomcat was already present when iManager was installed or" & (chr(13) & chr(10)) & "Tomcat is running as a batch file." & (chr(13) & chr(10)) & "Please manually unload Tomcat and then press OK to continue." & (chr(13) & chr(10)) & "Press Cancel to abort the iManager update.", VBOKCANCEL, "Security Update 8")
			imansvc = "-1"
		end if
		
		if sndmsg = "2" then imanver2 = "3"
	end if
end sub

sub pkinews
	Set secdll = CreateObject("Scripting.FileSystemObject")
    secfile = NDSRPATH + "\pki.dlm"
    If secdll.FileExists(secfile) Then
		secexist = secdll.GetFileVersion(secfile)
		
		If (secexist <= "2.7.7") Then
			ipki = "0"
		End If
	End If

	secfile = NDSRPATH + "\ntls.dll"
    If secdll.FileExists(secfile) Then
		on error resume next
		secexist = NULL	
		secexist = secdll.GetFileVersion(secfile)
		
		If (secexist <= "1.8.3") Then
			intls = "0"
		ElseIf (secexist = Null) Then
			intls = "0"
		ElseIf (secexist = "") Then
			intls = "0"
		End If
      
	End If

	Set rs = CreateObject("WScript.Shell")

	on error resume next
	imanloc = rs.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Novell iManager\InstallLocation")
	imandir = InStr(imanloc, "webapps")
	imandir = imandir-2
	iManPath = Mid(imanloc,1,imandir)
	
	if NDSRPATH = "" then
		if iManPath <> "" then NDSRPATH = iManPath
	end if
			
	secfile = iManPath + "\bin\NPKIT.dll"
    If secdll.FileExists(secfile) Then
        secexist = secdll.GetFileVersion(secfile)
		If (secexist <= "2.7.7") Then
			impki = "0"
		End If
	End If
	
	secfile = iManPath + "\bin\NTLS.dll"
    If secdll.FileExists(secfile) Then
        secexist = secdll.GetFileVersion(secfile)
		If (secexist <= "1.8.3") Then
			imntls = "0"
		End If
	End If
end sub

sub pkis
	Set secdll = CreateObject("Scripting.FileSystemObject")
    secfile = NDSRPATH + "\PKIAPI.dll"

    If secdll.FileExists(secfile) Then
		secexist = secdll.GetFileVersion(secfile)
		If (secexist <= "2.7.7") Then
			ipkiold = "0"
		End If
	End If
end sub

sub CS1s
	Set secdll = CreateObject("Scripting.FileSystemObject")
    secfile = "c:\Novell\consoleone\1.2\bin\PKIWrap.dll"

    If secdll.FileExists(secfile) Then
		secexist = secdll.GetFileVersion(secfile)
		If (secexist <= "2.7.7") Then
			ics1 = "0"
		End If
	End If
end sub

sub imanvers
	on error resume next
	imanver = rs.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Novell iManager\DisplayVersion")
    
	if imanver2 = "3" then imanver = "999"
	if (imanver >= "2.0.2") then imanver2 = "0"
	if (imanver >= "2.1") then imanver2 = "1"
end sub

sub nicivers
	On Error Resume Next
	nicikey = rs.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\{F02DBC5D-33E3-45E9-B0F8-B7745229ED1C}\DisplayName")	
	niciver = InStr(nicikey, "2.")
	niciend = InStr(niciver,nicikey, ")",1)
	pathlength = niciend - niciver
	niciversion = Mid(nicikey,niciver,pathlength)
	
    niciver2 = 1
	
	If (niciversion >= "2.6.7") Then niciver2 = "0"
end sub

sub edirvers
	on error resume next
	redver = rs.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\NDSonNT\DisplayName")
	
	If (redver = "") Then 
		redver = "No eDirectory"
		redver2 = "4"
		exit sub
	end if
	
	If (redver => "Novell eDirectory 8.7.4") Then
		redver2 = "4"
		exit sub
	end if
	
	If (redver => "Novell eDirectory 8.7.3") Then 
		redver2 = "1"
		exit sub
	end if
	
	If (redver >= "Novell eDirectory 8.7.1") then
		redver2 = "2"
		exit sub
	end if
	
	If (redver = "Novell eDirectory 8.6.2") then
		redver2 = "3"
		exit sub
	end if

rem This is a special case for Japanese Windows Server.  eDir 8.7.3 changes the registry key to Novell eDirectory	
	If (redver = "Novell eDirectory") then
		redver2 = "1"
		exit sub
	end if

	redver2 = "4"
end sub

sub CS1PathFind
	Set rs = CreateObject("WScript.Shell")
		
	on error resume next
	CS1PATH = rs.RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\ConsoleOne.exe\Path")

	if CS1PATH = "" then CS1PATH = "Not Installed"
end sub

rem THIS IS THE MAIN PROGRAM

dim ipki, ipkiold, ics1, NDSRPATH, iManPath, imansvc
dim redver2, imanver2, niciver2, NDSver, redver, imanver, niciversion, CS1PATH

readme = MsgBox("Do you want to view the readme?", VBYesNo, "Security Update 8")

Set rs = CreateObject("WScript.Shell")

ipki = 1
impki = 1
ipkiold = 1
ics1 = 1
intls = 1
imanver2 = 1
imntls = 1

rem get the NDS dib path
NDSPaths

rem install pki to eDir 8.7.1 or greater
pkinews

rem install older pki to eDir 8.7.0 or less
pkis

rem install Console One modules
CS1s

rem get iManager verions
imanvers

rem get NICI versions
nicivers

rem get eDirectory versions
edirvers

rem get CS1 Path
CS1PathFind


Set fs = CreateObject("Scripting.FileSystemObject") 
strFN = fs.BuildPath(Wscript.ScriptFullName & "\..", "~versioning.bat") 
strFN = fs.GetAbsolutePathName(strFN) 
Set ts = fs.OpenTextFile(strFN, 2, True)
ts.WriteLine "set NDSR_PATH=" & NDSRPATH
ts.WriteLine "set ipkiold=" & ipkiold
ts.WriteLine "set ipki=" & ipki
ts.WriteLine "set ics1=" & ics1
ts.WriteLine "set impki=" & impki
ts.WriteLine "set impath=" & iManPath
ts.WriteLine "set NDSver=" & redver2
ts.WriteLine "set iManVer=" & imanver2
ts.WriteLine "set NICIver=" & niciver2
ts.Writeline "set sNICIver=" & niciversion
ts.Writeline "set siManVer=" & imanver
ts.Writeline "set sNDSver=" & redver
ts.Writeline "set view=" & readme
ts.Writeline "set imansvc=" & imansvc
ts.WriteLine "set CS1PATH=" & CS1PATH
ts.WriteLine "set imntls=" & imntls
ts.WriteLine "set intls=" & intls
ts.Close

If (niciver2 = 1) then MsgBox ("NICI version " & niciversion & " was detected" & (chr(13) & chr(10)) & "NICI 2.6.7 or greater must be installed before applying this patch!"), VBOKOnly, "Security Update 8" 

If (redver2 = 4) then 
	if (imanver2 = 1) then
		MsgBox (redver & " was detected" & (chr(13) & chr(10)) & "Security Update 8 is not supported for this version of eDirectory!"), VBOKOnly, "Security Update 8" 
    	end if
end if

If iManPath <> "" then
	If (imanver2 = 1) then
		If (imanver < "2.1") then
			MsgBox("iManager version " & imanver & " was detected. Security Update 8 can not patch this version." & (chr(13) & chr(10)) & "Please update iManager and run Security Update 8 again to secure your iManager system.")
		end if
	end if
end if
	




