@echo. |date|find "current"
@echo. |time|find "current"

@echo Installing Security Update 8 

start /w wscript.exe secupd.vbs
call ~versioning.bat

@echo %view%
if %view% == 7 goto noviewreadme

call notepad install.txt

:noviewreadme

rem make sure NICI is 2.6.7 or greater
	@echo NICIver %NICIver%
	@echo NICI version %sNICIver% is installed
	if %NICIver% == 1 goto failnici

rem make sure iManager 2.0.2 or greater is installed
	@echo iManager version %siManVer% was detected.
	@echo iManver %iManver%
	if %iManVer% == 1 goto chkedir

rem don't backrev pki
	@echo impki = %impki%
	if %impki% == 1 goto chkedir

rem install iManager
	if %imansvc% == Tomcat goto stoptomcat
	goto backupiManager
	
rem stop tomcat
:stoptomcat
	@echo Stopping Tomcat Service > CON
	@echo ... > CON
	Net Stop "Tomcat"
	
:backupiManager
	if NOT exist %impath%\oldsu8\ md %impath%\oldsu8\

rem backup files
	@echo backing up files to %impath%\oldsu8\
	@echo backing up files to %impath%\oldsu8\ > CON
	@echo ... > CON
	@echo . > CON
	
	if exist %impath%\oldsu8\iManager del %impath%\oldsu8\iManager
	copy %impath%\webapps\nps\WEB-INF\lib\npki.jar %impath%\oldsu8\
	copy %impath%\webapps\nps\WEB-INF\bin\npkiapi.dll %impath%\oldsu8\
	copy %impath%\webapps\nps\WEB-INF\bin\npkit.dll %impath%\oldsu8\
	copy %impath%\webapps\nps\WEB-INF\bin\ntls.dll %impath%\oldsu8\

	set cpl="%impath%\webapps\nps\WEB-INF\lib"
	set cpb="%impath%\webapps\nps\WEB-INF\bin"
	set cpfile=0
	@echo Copying new iManager files  > CON
	@echo Please Wait ...   > CON
	@echo . > CON
	
rem new files web-inf
:imancp
	if %cpfile% == 2 goto chktomcat
	if %cpfile% == 1 set cpb="%impath%"\bin
	if %cpfile% == 1 set cpl="%impath%"\lib

	if exist %cpl% attrib %cpl%\npki.jar -r
	if exist %cpl% copy edir87x\npki.jar %cpl%
	
	attrib %cpb%\npkiapi.dll -r 
	copy edir87x\npkiapi.dll %cpb%
	
	attrib %cpb%\npkit.dll -r
	copy edir87x\npkit.dll %cpb%
	
	attrib %cpb%\ntls.dll -r
	copy edir87x\ntls.dll %cpb%
	
	if %cpfile% == 1 set cpfile=2
	if %cpfile% == 0 set cpfile=1
	goto imancp
	
:chktomcat
rem make sure tomcat was not stopped manually
	if %imansvc% == Tomcat goto starttomcat
	goto chkdisplay
	
rem start tomcat
:starttomcat
	@echo . > CON
	@echo Starting Tomcat Service > CON
	@echo ... > CON
	Net Start "Tomcat"
	if ERRORLEVEL 1 goto tcerror
	goto chkdisplay
	
rem handle any tomcat start errors
:tcerror
	@echo . > CON
	@echo Tomcat failed to start. You will need to manually start the Tomcat service. > CON
	@echo WARNING!!!!
	@echo Tomcat failed to start. You will need to manually start the Tomcat service.
	set tcerrorstr=1
	@echo tcerrorstr=%tcerrorstr% >> ~versioning.bat

:chkdisplay
	if %NDSver% == 4 goto displaylogs
	if %NDSver% == "" goto displaylogs
	goto chkedir
	
:chkedir
	@echo NDSver = %NDSver%
	if %NDSver% == 4 goto end
	if %NDSver% == "" goto end
		
	@echo Stopping NDS Service > CON
	Net Stop "nds server0"
	
	if not exist %NDSR_PATH%\oldsu8 md %NDSR_PATH%\oldsu8
	
	if %NDSver% == 3 goto edir86

:edir87
	@echo Backing up old Files > CON
	@echo . > CON 

	copy %NDSR_PATH%\npki.jar %NDSR_PATH%\oldsu8
	copy %NDSR_PATH%\npkiapi.dll %NDSR_PATH%\oldsu8
	copy %NDSR_PATH%\PKIAPI.DLL %NDSR_PATH%\oldsu8
	copy %NDSR_PATH%\PKI.dlm %NDSR_PATH%\oldsu8
	copy %NDSR_PATH%\npkit.dll %NDSR_PATH%\oldsu8
	copy %NDSR_PATH%\ntls.dll %NDSR_PATH%\oldsu8

	@echo The existing security files have been backed up to %NDSR_PATH% > CON

	@echo Copying new files  > CON
	@echo Please Wait ...   > CON
	@echo . > CON

	if %ics1% == 0 goto cs1
	goto pki

:cs1
	if %CS1PATH% == "Not Installed" goto pki
	if exist %CS1PATH%\bin\PKIWrap.dll attrib %CS1PATH%\bin\PKIWrap.dll -r
	copy CS1\pkiwrap.dll %CS1PATH%\bin


:pki
	if %ipki% == 1 goto startnds

	attrib %NDSR_PATH%\npkiapi.dll -r
	copy edir87x\npkiapi.dll %NDSR_PATH%
	
	attrib %NDSR_PATH%\npki.jar -r
	copy edir87x\npki.jar %NDSR_PATH%

	attrib %NDSR_PATH%\PKIAPI.DLL -r
	copy edir87x\PKIAPI.DLL %NDSR_PATH%

	attrib %NDSR_PATH%\PKI.DLM -r
	copy edir87x\PKI.DLM %NDSR_PATH%

	attrib %NDSR_PATH%\npkit.dll -r
	copy edir87x\npkit.dll %NDSR_PATH%

:ntls
	if %intls% == 1 goto startnds
	attrib %NDSR_PATH%\NTLS.DLL -R
	copy edir87x\NTLS.DLL %NDSR_PATH%

	goto startnds

:edir86
	@echo %ipkiold%

	@echo Copying new files  > CON
	@echo Please Wait ...   > CON
	@echo . > CON

	copy %NDSR_PATH%\PKIWrap.dll %NDSR_PATH%\oldsu8
	copy %NDSR_PATH%\PKIAPI.DLL %NDSR_PATH%\oldsu8

	@echo The existing security files have been backed up to %NDSR_PATH%\oldsu8 > CON 

	if %ics1% == 0 goto cs1
	goto pkiold

	if %CS1PATH% == "Not Installed" goto pkiold
	attrib %CS1PATH%\bin\pkiwrap.dll -r
	copy CS1\pkiwrap.dll %CS1PATH%\bin


:pkiold
	if %ipkiold% == 1 goto startnds

	attrib %NDSR_PATH%\npkiapi.dll -r
	copy edir862\PKIAPI.dll %NDSR_PATH%

	attrib %NDSR_PATH%\PKIAPI.DLL -r
	copy edir862\PKIWrapp.dll %NDSR_PATH%

:startnds
	@echo Starting NDS Service  > CON
	@echo . > CON

	Net Start "nds server0"
	
	@echo NDS Service Successfully Started > CON

:displaylogs
	start /w wscript.exe displog.vbs 
	call ~view.bat 
	del ~view.bat
	if %dislog% == 7 goto Exit

	call notepad install.log

:Exit
	if exist %NDSR_PATH%\SecUpd attrib %NDSR_PATH%\SecUpd -h -r
	if exist %NDSR_PATH%\SecUpd del %NDSR_PATH%\SecUpd
	@echo 6 > %NDSR_PATH%\SecUpd
	attrib %NDSR_PATH%\SecUpd +h +r

	if exist %NDSR_PATH%\SecUpd1 del %NDSR_PATH%\SecUpd1
	if exist %NDSR_PATH%\SecUpd2 del %NDSR_PATH%\SecUpd2
	if exist %NDSR_PATH%\SecUpd3 del %NDSR_PATH%\SecUpd3
	goto end

:failnici
	@echo NICI version %NICIstring% was detected.  > con
	
:end
	del ~versioning.bat
	del ~view.bat
